import { useRef, useEffect } from 'react';
export { useEffectStrictModeSafe };
function useEffectStrictModeSafe(effect, deps) {
    const isPendingTeardownRef = useRef(false);
    useEffect(() => {
        const teardown = effect();
        if (teardown) {
            isPendingTeardownRef.current = false;
            return () => {
                if (isPendingTeardownRef.current) {
                    return;
                }
                isPendingTeardownRef.current = true;
                (async () => {
                    await undefined;
                    if (isPendingTeardownRef.current) {
                        teardown();
                    }
                })();
            };
        }
    }, deps);
}
//# sourceMappingURL=useEffectStrictModeSafe.js.map