import { useRef } from 'react';
export { useRefWithInitialValue };
function useRefWithInitialValue(initialValueFn) {
    const isInitializedRef = useRef();
    const ref = useRef();
    if (!isInitializedRef.current) {
        isInitializedRef.current = true;
        ref.current = initialValueFn();
    }
    const refNonNullCurrent = ref;
    return refNonNullCurrent;
}
//# sourceMappingURL=useRefWithInitialValue.js.map